'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * @private
 *
 * @constant {boolean}
 * @default
 */
var IS_PRODUCTION = exports.IS_PRODUCTION = !!(process && process.env && process.env.NODE_ENV === 'production');

/**
 * @private
 *
 * @constant {Symbol}
 */
var CRIO_SYMBOL = exports.CRIO_SYMBOL = Symbol('Crio');

/**
 * @private
 *
 * @constant {{configurable: boolean, enumerable: boolean, value: function(): Object, writable: boolean}}
 */
var ITERATOR_PROPERTY_DESCRIPTOR = exports.ITERATOR_PROPERTY_DESCRIPTOR = {
  configurable: false,
  enumerable: false,
  value: function iterator() {
    var _this = this;

    var keys = Object.getOwnPropertyNames(this);
    var length = keys.length;

    var index = -1,
        value = void 0;

    return {
      next: function next() {
        if (++index < length) {
          value = _this[keys[index]];

          return {
            done: false,
            value: value
          };
        } else {
          return {
            done: true
          };
        }
      }
    };
  },
  writable: true
};

/**
 * @private
 *
 * @constant {{configurable: boolean, enumerable: boolean, value: Object, writable: boolean}}
 */
var UNSCOPABLES_PROPERTY_DESCRIPTOR = exports.UNSCOPABLES_PROPERTY_DESCRIPTOR = {
  configurable: true,
  enumerable: false,
  value: {
    copyWithin: true,
    entries: true,
    fill: true,
    find: true,
    findIndex: true,
    includes: true,
    keys: true
  },
  writable: false
};

/**
 * @private
 *
 * @constant {Symbol}
 */
var CRIO_TYPE = exports.CRIO_TYPE = Symbol('Crio type');

/**
 * @private
 *
 * @constant {string}
 * @default
 */
var CRIO_ARRAY_TYPE = exports.CRIO_ARRAY_TYPE = 'CrioArray';

/**
 * @private
 *
 * @constant {string}
 * @default
 */
var CRIO_OBJECT_TYPE = exports.CRIO_OBJECT_TYPE = 'CrioObject';

/**
 * @private
 *
 * @constant {Symbol|number}
 */
var REACT_ELEMENT_TYPE = exports.REACT_ELEMENT_TYPE = typeof Symbol === 'function' && Symbol.for && Symbol.for('react.element') || 0xeac7;